/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.16 from the
 * contents of CDROM.xs. Do not edit this file, edit CDROM.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CDROM.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <linux/cdrom.h>

#include "const-c.inc"

#define WARN_OFF \
    SV *oldwarn = PL_curcop->cop_warnings; \
    PL_curcop->cop_warnings = pWARN_NONE;

#define WARN_ON \
    PL_curcop->cop_warnings = oldwarn;

#define DEVICE_CDROM_NO_ERROR           0
#define DEVICE_CDROM_NO_OPEN            1
#define DEVICE_CDROM_NO_CDROM           2
#define DEVICE_CDROM_NO_TOCHDR          3
#define DEVICE_CDROM_NO_AUDIO           4
#define DEVICE_CDROM_NO_DISC_STATUS     5
#define DEVICE_CDROM_IDX_OUT_OF_BOUNDS  6
#define DEVICE_CDROM_IOCTL_ERROR        7

typedef struct CDROM {
    int                 fd;
    char                *device;    /* need device name for reopening it */
    int                 caps;       /* capabilities as returned by CDROM_GET_CAPABILITY */
    struct cdrom_tochdr *toch;   
    int                 num_frames;
} CDROM;

typedef struct CDROM_ADDR {
    union cdrom_addr addr;
    int type;
} CDROM_ADDR;

typedef struct cdrom_subchnl CDROM_SUBCHANNEL;

typedef struct cdrom_tocentry CDROM_TOCENTRY;

/* these two are derived from the kernel's drivers/cdrom/cdrom.c */
int msf_to_lba (char m, char s, char f) {
    return (((m * CD_SECS) + s) * CD_FRAMES + f) - CD_MSF_OFFSET;
}
void lba_to_msf (int lba, char *m, char *s, char *f) {
    *f = lba % CD_FRAMES;
    lba /= CD_FRAMES;
    lba += 2;
    *s = lba % CD_SECS;
    *m = lba / CD_SECS;
}

int reopen (CDROM *self) {
    close(self->fd);
    if ((self->fd = open(self->device, O_RDONLY|O_NONBLOCK)) == -1)
        return 0;
    return 1;
}

void to_lba (CDROM_ADDR *self) {
    if (self->type == CDROM_LBA)
        return;
    self->addr.lba = msf_to_lba(self->addr.msf.minute, self->addr.msf.second, self->addr.msf.frame);
    self->type = CDROM_LBA;
}

int
num_frames (CDROM *self) {
    long num;
    if (ioctl(self->fd, CDROM_LAST_WRITTEN, &num) == -1)
        return -1;
    return (self->num_frames = num);
}

/* $Linux::CDROM::error handling */
SV *CDERR;
void reg_error (int error) {
    STRLEN n_a;
    CDERR = get_sv("Linux::CDROM::error", FALSE);
    SvIVX(CDERR) = error;
    switch (error) {
        case DEVICE_CDROM_NO_ERROR:
            sv_setpvn(CDERR, "", 0);
            break;
        case DEVICE_CDROM_NO_OPEN:
            sv_setpvn(CDERR, "Couldn't open device: ", 22);
        case DEVICE_CDROM_NO_CDROM:
            sv_setpvn(CDERR, "Device is no CDROM drive: ", 26);
        case DEVICE_CDROM_NO_TOCHDR:
            sv_setpvn(CDERR, "Couldn't read TOC header: ", 26);
        case DEVICE_CDROM_NO_AUDIO:
            sv_setpvn(CDERR, "No Audio-CD: ", 13);
        case DEVICE_CDROM_NO_DISC_STATUS:
            sv_setpvn(CDERR, "Couldn't retrieve disc-status: ", 31);
        case DEVICE_CDROM_IDX_OUT_OF_BOUNDS:
            sv_setpvn(CDERR, "Index out of bounds: ", 21);
        case DEVICE_CDROM_IOCTL_ERROR:
            sv_setpvn(CDERR, "Generic ioctl error: ", 21);
        default: 
            sv_catpv(CDERR, SvPV(get_sv("!", FALSE), n_a));
    }
}

SV *DATSIZE;

#define INC_DATSIZE(i)      SvIVX(DATSIZE) += i
#define RESET_DATSIZE       SvIVX(DATSIZE) = 0

#line 127 "CDROM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 269 "CDROM.c"

/* INCLUDE:  Including 'const-xs.inc' from 'CDROM.xs' */


XS_EUPXS(XS_Linux__CDROM_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 294 "CDROM.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Linux::CDROM macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Linux::CDROM macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Linux::CDROM macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 372 "CDROM.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'CDROM.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Linux__CDROM_reset_datasize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_reset_datasize)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 144 "CDROM.xs"
    {
        RESET_DATSIZE;
    }
#line 392 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_get_datasize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_get_datasize)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 151 "CDROM.xs"
    {
        RETVAL = SvIVX(DATSIZE);
    }
#line 410 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, device");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	device = (char *)SvPV_nolen(ST(1))
;
#line 162 "CDROM.xs"
        CDROM *cdrom;
        int fd;
        int caps;
#line 432 "CDROM.c"
	CDROM *	RETVAL;
#line 166 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);
        if ((fd = open(device, O_RDONLY|O_NONBLOCK)) == -1) {
            reg_error(DEVICE_CDROM_NO_OPEN);
            XSRETURN_UNDEF;
        }
        if ((caps = ioctl(fd, CDROM_GET_CAPABILITY)) == -1) {
            reg_error(DEVICE_CDROM_NO_CDROM);
            close(fd);
            XSRETURN_UNDEF;
        } 

        New(0, cdrom, 1, CDROM);
        cdrom->fd = fd;
        cdrom->device = savepv(device);
        cdrom->caps = caps;
        cdrom->toch = NULL;
        cdrom->num_frames = -1;
        RETVAL = cdrom;
    }
#line 455 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), CLASS, (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_fh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_fh)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 193 "CDROM.xs"
        char mode[8];
        GV *gv;
        STRLEN modlen;
#line 475 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::fh() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 197 "CDROM.xs"
    {
        modlen = sprintf(mode, "<&%i", self->fd);
        gv = newGVgen("main");
        sv_dump((SV*)gv);
        do_openn(gv, mode, modlen, FALSE, O_RDONLY|O_NONBLOCK, 0, Nullfp, (SV**)NULL, 0);
        sv_setsv(ST(0), sv_2mortal(newRV_noinc((SV*)gv)));
        XSRETURN(1);
    }
#line 493 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::close() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 210 "CDROM.xs"
    {
        if (close(self->fd) == -1)
            XSRETURN_UNDEF;
        self->fd = -1;
        XSRETURN_YES;
    }
#line 522 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_reopen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_reopen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::reopen() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 221 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);
        if (reopen(self)) 
            XSRETURN_YES;
        reg_error(DEVICE_CDROM_NO_OPEN);
        XSRETURN_UNDEF;
    }
#line 552 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_capabilities)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::capabilities() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 233 "CDROM.xs"
    {
        if (self->caps == -2) {
            self->caps = ioctl(self->fd, CDROM_GET_CAPABILITY);
            if (self->caps == -1)
                XSRETURN_UNDEF;
        }
        RETVAL = self->caps;
    }
#line 585 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_drive_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_drive_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 248 "CDROM.xs"
        int status;
#line 602 "CDROM.c"
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::drive_status() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 250 "CDROM.xs"
    {
        if ((status = ioctl(self->fd, CDROM_DRIVE_STATUS)) == -1)
            XSRETURN_UNDEF;
        RETVAL = status;
    }
#line 619 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_disc_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_disc_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 262 "CDROM.xs"
        int status;
#line 636 "CDROM.c"
	UV	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::disc_status() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 264 "CDROM.xs"
    {
        if ((status = ioctl(self->fd, CDROM_DISC_STATUS)) == -1)
            XSRETURN_UNDEF;
        RETVAL = status;
    }
#line 653 "CDROM.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_num_frames); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_num_frames)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 276 "CDROM.xs"
        long last;
#line 670 "CDROM.c"
	NV	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::num_frames() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 278 "CDROM.xs"
    {
        if (self->num_frames == -1)
            if (ioctl(self->fd, CDROM_LAST_WRITTEN, &last) == -1)
                XSRETURN_UNDEF;
        RETVAL = last;
    }
#line 688 "CDROM.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_next_writable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_next_writable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 291 "CDROM.xs"
        long next;
#line 705 "CDROM.c"
	NV	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::next_writable() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 293 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROM_NEXT_WRITABLE, &next) == -1)
            XSRETURN_UNDEF;
        RETVAL = next;
    }
#line 722 "CDROM.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_get_spindown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_get_spindown)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 305 "CDROM.xs"
        int sd;
#line 739 "CDROM.c"
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::get_spindown() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 307 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMGETSPINDOWN, &sd) == -1)
            XSRETURN_UNDEF;
        RETVAL = (char)sd;
    }
#line 756 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_set_spindown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_set_spindown)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, sd");
    {
	CDROM *	self;
	int	sd = (int)SvIV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::set_spindown() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 320 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMSETSPINDOWN, (void*)&sd) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 787 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::reset() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 330 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMRESET) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 815 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_eject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_eject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::eject() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 340 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMEJECT) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 843 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_auto_eject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_auto_eject)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	CDROM *	self;
	int	val = (int)SvIV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::auto_eject() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 351 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMEJECT_SW, val) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 873 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_close_tray); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_close_tray)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::close_tray() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 361 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMCLOSETRAY, 0) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 901 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_lock_door); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_lock_door)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	CDROM *	self;
	int	val = (int)SvIV(ST(1))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::lock_door() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 372 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROM_LOCKDOOR, val) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 931 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_media_changed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_media_changed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 382 "CDROM.xs"
        int changed;
#line 947 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::media_changed() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 384 "CDROM.xs"
    {
        if ((changed = ioctl(self->fd, CDROM_MEDIA_CHANGED)) == -1)
            XSRETURN_UNDEF;
        if (changed)
            XSRETURN_YES;
        else
            XSRETURN_NO;
    }
#line 965 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_mcn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_mcn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 397 "CDROM.xs"
        struct cdrom_mcn mcn;
#line 981 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::mcn() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 399 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROM_GET_MCN, &mcn) == -1)
            XSRETURN_UNDEF;
        ST(0) = sv_2mortal(newSVpvn(mcn.medium_catalog_number, 13));
        XSRETURN(1);
    }
#line 997 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_get_vol); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_get_vol)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 411 "CDROM.xs"
        struct cdrom_volctrl vol;
#line 1013 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::get_vol() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 413 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMVOLREAD, &vol) == -1)
            XSRETURN_UNDEF;
        EXTEND(SP, 4);
        ST(0) = sv_2mortal(newSVuv(vol.channel0));
        ST(1) = sv_2mortal(newSVuv(vol.channel1));
        ST(2) = sv_2mortal(newSVuv(vol.channel2));
        ST(3) = sv_2mortal(newSVuv(vol.channel3));
        XSRETURN(4);
    }
#line 1033 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_set_vol); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_set_vol)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, v0, v1, v2, v3");
    {
	CDROM *	self;
	unsigned int	v0 = (unsigned int)SvUV(ST(1))
;
	unsigned int	v1 = (unsigned int)SvUV(ST(2))
;
	unsigned int	v2 = (unsigned int)SvUV(ST(3))
;
	unsigned int	v3 = (unsigned int)SvUV(ST(4))
;
#line 432 "CDROM.xs"
        struct cdrom_volctrl vol;
#line 1057 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::set_vol() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 434 "CDROM.xs"
    {
        vol.channel0 = v0;
        vol.channel1 = v1;
        vol.channel2 = v2;
        vol.channel3 = v3;
        if (ioctl(self->fd, CDROMVOLCTRL, &vol) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1076 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_play_msf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_play_msf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, from, to");
    {
	CDROM *	self;
	CDROM_ADDR *	from;
	CDROM_ADDR *	to;
#line 450 "CDROM.xs"
        struct cdrom_msf msf;
        int status;
#line 1095 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::play_msf() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		from = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Linux::CDROM::play_msf() -- from is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVMG) )
		to = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(2) ));
	else{
		warn( "Linux::CDROM::play_msf() -- to is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 453 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);

        if ((status = ioctl(self->fd, CDROM_DISC_STATUS)) == -1) {
            reg_error(DEVICE_CDROM_NO_DISC_STATUS);
            XSRETURN_UNDEF;
        }

        if (! status & CDS_AUDIO) {
            reg_error(DEVICE_CDROM_NO_AUDIO);
            XSRETURN_UNDEF;
        }

        lba_to_msf(from->addr.lba, &msf.cdmsf_min0, &msf.cdmsf_sec0, &msf.cdmsf_frame0);
        lba_to_msf(to->addr.lba, &msf.cdmsf_min1, &msf.cdmsf_sec1, &msf.cdmsf_frame1);
        if (ioctl(self->fd, CDROMPLAYMSF, &msf) == -1) {
            reg_error(DEVICE_CDROM_IOCTL_ERROR);
            XSRETURN_UNDEF;
        }
        XSRETURN_YES;
    }
#line 1142 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_play_ti); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_play_ti)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	CDROM *	self;
#line 479 "CDROM.xs"
        register int i;
        int fromtr  = 0;
        int fromidx = 0;
        int totr    = 0;
        int toidx   = 0;
        struct cdrom_ti ti;
        int dotochdr = 2;
        int status;
        STRLEN n_a;
#line 1166 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::play_ti() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 489 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);

        if ((status = ioctl(self->fd, CDROM_DISC_STATUS)) == -1) {
            reg_error(DEVICE_CDROM_NO_DISC_STATUS);
            XSRETURN_UNDEF;
        }

        if (! status & CDS_AUDIO) {
            reg_error(DEVICE_CDROM_NO_AUDIO);
            XSRETURN_UNDEF;
        }

        /* temporarily shut up warnings */
        WARN_OFF;
        for (i = 1; i+1 < items; i++) {
            if (strEQ(SvPV(ST(i), n_a), "-from")) {
                i++;
                fromtr = SvIV(ST(i));
                dotochdr--;
                continue;
            } 
            if (strEQ(SvPV(ST(i), n_a), "-to")) {
                i++;
                totr = SvIV(ST(i));
                dotochdr--;
                continue;
            }
            if (strEQ(SvPV(ST(i), n_a),  "-fromidx")) {
                i++;
                fromidx = SvIV(ST(i));
                continue;
            }
            if (strEQ(SvPV(ST(i), n_a), "-toidx")) {
                i++;
                toidx = SvIV(ST(i));
                continue;
            }
        }
        /* warning-prone code done so restore old
         * warnings bit-mask */
        WARN_ON;

        if (dotochdr) {
            if (!self->toch) {
                New(0, self->toch, 1, struct cdrom_tochdr);
                if (ioctl(self->fd, CDROMREADTOCHDR, self->toch) == -1) {
                    reg_error(DEVICE_CDROM_NO_TOCHDR);
                    XSRETURN_UNDEF;
                }
                else {
                    fromtr = 1;
                    totr = self->toch->cdth_trk1;
                }
            }
        }

        ti.cdti_trk0 = (__u8)fromtr;
        ti.cdti_ind0 = (__u8)fromidx;
        ti.cdti_trk1 = (__u8)totr;
        ti.cdti_ind1 = (__u8)toidx;

        if (ioctl(self->fd, CDROMPLAYTRKIND, &ti) == -1) {
            reg_error(DEVICE_CDROM_IOCTL_ERROR);
            XSRETURN_UNDEF;
        }
        XSRETURN_YES;
    }
#line 1244 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_pause); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_pause)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::pause() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 562 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMPAUSE) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1272 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::resume() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 572 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMRESUME) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1300 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::start() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 582 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMSTART) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1328 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::stop() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 592 "CDROM.xs"
    {
        if (ioctl(self->fd, CDROMSTOP) == -1)
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1356 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_read1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_read1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, addr");
    {
	CDROM *	self;
	CDROM_ADDR *	addr;
#line 603 "CDROM.xs"
        struct cdrom_msf *data;
#line 1373 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::read1() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		addr = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Linux::CDROM::read1() -- addr is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 605 "CDROM.xs"
    {
        New(0, data, CD_FRAMESIZE, char);

        lba_to_msf(addr->addr.lba, &data->cdmsf_min0, &data->cdmsf_sec0, &data->cdmsf_frame0);

        if (ioctl(self->fd, CDROMREADMODE1, data) == -1) {
            Safefree(data);
            XSRETURN_UNDEF;
        }

        ST(0) = sv_newmortal();
        sv_usepvn(ST(0), (char*)data, CD_FRAMESIZE);
        XSRETURN(1);
    }
#line 1405 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_read2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_read2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, addr");
    {
	CDROM *	self;
	CDROM_ADDR *	addr;
#line 625 "CDROM.xs"
        struct cdrom_msf *data;
#line 1422 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::read2() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		addr = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Linux::CDROM::read2() -- addr is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 627 "CDROM.xs"
    {
        New(0, data, CD_FRAMESIZE_RAW0, char);

        lba_to_msf(addr->addr.lba, &data->cdmsf_min0, &data->cdmsf_sec0, &data->cdmsf_frame0);

        if (ioctl(self->fd, CDROMREADMODE2, data) == -1) {
            Safefree(data);
            XSRETURN_UNDEF;
        }

        ST(0) = sv_newmortal();
        sv_usepvn(ST(0), (char*)data, CD_FRAMESIZE_RAW0);
        XSRETURN(1);
    }
#line 1454 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_read_audio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_read_audio)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, addr, nframes");
    {
	CDROM *	self;
	CDROM_ADDR *	addr;
	int	nframes = (int)SvIV(ST(2))
;
#line 648 "CDROM.xs"
        struct cdrom_read_audio audio;
        int ret;
        int status;
#line 1475 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::read_audio() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		addr = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Linux::CDROM::read_audio() -- addr is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 652 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);

        /* bound checking stuff */

        if (self->num_frames == -1)
            status = num_frames(self);

        if (status >= 0) {
            if (addr->addr.lba >= self->num_frames) {
                reg_error(DEVICE_CDROM_IDX_OUT_OF_BOUNDS);
                XSRETURN_UNDEF;
            }
            /* detect reading-beyond-last-frame case and correct
             * the number of frames */
            if (addr->addr.lba + nframes - 1 >= self->num_frames)
                nframes = self->num_frames - addr->addr.lba;
        }

        Newz(0, audio.buf, nframes * CD_FRAMESIZE_RAW, __u8);
        audio.addr = addr->addr;
        audio.addr_format = addr->type;
        audio.nframes = nframes;
        if ((ret = ioctl(self->fd, CDROMREADAUDIO, &audio)) == -1) {
            Safefree(audio.buf);
            XSRETURN_UNDEF;
        }

        INC_DATSIZE(CD_FRAMESIZE_RAW * nframes);
        ST(0) = sv_newmortal();
        sv_usepvn(ST(0), audio.buf, nframes*CD_FRAMESIZE_RAW);
        XSRETURN(1);
    }
#line 1526 "CDROM.c"
    }
    XSRETURN(1);
}

#if 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Linux__CDROM_read_cooked); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_read_cooked)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, lba");
    {
	CDROM *	self;
	int	lba = (int)SvIV(ST(1))
;
#line 692 "CDROM.xs"
        struct cdrom_msf *data;
#line 1547 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::read_cooked() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 694 "CDROM.xs"
    {
        New(0, (char*)data, CD_FRAMESIZE, char);

        lba_to_msf(lba, &data->cdmsf_min0, &data->cdmsf_sec0, &data->cdmsf_frame0);

        if (ioctl(self->fd, CDROMREADCOOKED, data) == -1) {
            Safefree(data);
            XSRETURN_UNDEF;
        }

        ST(0) = sv_newmortal();
        sv_usepvn(ST(0), (char*)data, CD_FRAMESIZE);
        XSRETURN(1);
    }
#line 1571 "CDROM.c"
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Linux__CDROM_read_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_read_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, addr");
    {
	CDROM *	self;
	CDROM_ADDR *	addr;
#line 716 "CDROM.xs"
        struct cdrom_msf *data;
#line 1589 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::read_raw() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	if( sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG) )
		addr = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(1) ));
	else{
		warn( "Linux::CDROM::read_raw() -- addr is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 718 "CDROM.xs"
    {
        New(0, data, CD_FRAMESIZE_RAW, char);

        lba_to_msf(addr->addr.lba, &data->cdmsf_min0, &data->cdmsf_sec0, &data->cdmsf_frame0);

        if (ioctl(self->fd, CDROMREADRAW, data) == -1) {
            Safefree(data);
            XSRETURN_UNDEF;
        }

        ST(0) = sv_newmortal();
        sv_usepvn(ST(0), (char*)data, CD_FRAMESIZE_RAW);
        XSRETURN(1);
    }
#line 1621 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_poll)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 737 "CDROM.xs"
        CDROM_SUBCHANNEL *subch;
#line 1637 "CDROM.c"
	CDROM_SUBCHANNEL *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::poll() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 739 "CDROM.xs"
    {
        New(0, subch, 1, CDROM_SUBCHANNEL);
        subch->cdsc_format = CDROM_LBA;
        if (ioctl(self->fd, CDROMSUBCHNL, subch) == -1) {
            Safefree(subch);
            XSRETURN_UNDEF;
        }
        RETVAL = subch;
    }
#line 1657 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Subchannel", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_toc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_toc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::toc() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 755 "CDROM.xs"
    {
        if (!self->toch) {
            New(0, self->toch, 1, struct cdrom_tochdr);
            if (ioctl(self->fd, CDROMREADTOCHDR, self->toch) == -1) {
                Safefree(self->toch);
                XSRETURN_UNDEF;
            }
        }
        EXTEND(SP, 2);
        ST(0) = sv_2mortal(newSVuv(self->toch->cdth_trk0));
        ST(1) = sv_2mortal(newSVuv(self->toch->cdth_trk1));
        XSRETURN(2);
    }
#line 1695 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_toc_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_toc_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, idx");
    {
	CDROM *	self;
	int	idx = (int)SvIV(ST(1))
;
#line 774 "CDROM.xs"
        CDROM_TOCENTRY *entry;
#line 1713 "CDROM.c"
	CDROM_TOCENTRY *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::toc_entry() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 776 "CDROM.xs"
    {
        reg_error(DEVICE_CDROM_NO_ERROR);
        if (!self->toch) {
            New(0, self->toch, 1, struct cdrom_tochdr);
            if (ioctl(self->fd, CDROMREADTOCHDR, self->toch) == -1) {
                reg_error(DEVICE_CDROM_NO_TOCHDR);
                Safefree(self->toch);
                XSRETURN_UNDEF;
            }
        }

        if (idx < self->toch->cdth_trk0 || idx > self->toch->cdth_trk1 && idx != CDROM_LEADOUT) {
            reg_error(DEVICE_CDROM_IDX_OUT_OF_BOUNDS);
            XSRETURN_UNDEF;
        }

        New(0, entry, 1, CDROM_TOCENTRY);
        entry->cdte_track  = (__u8)idx;
        entry->cdte_format = CDROM_LBA;
        if (ioctl(self->fd, CDROMREADTOCENTRY, entry) == -1) {
            reg_error(DEVICE_CDROM_IOCTL_ERROR);
            Safefree(entry);
            XSRETURN_UNDEF;
        }
        RETVAL = entry;
    }
#line 1750 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::TocEntry", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM_is_multisession); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_is_multisession)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;
#line 809 "CDROM.xs"
        struct cdrom_multisession ms;
#line 1768 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::is_multisession() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 811 "CDROM.xs"
    {
        ms.addr_format = CDROM_LBA;
        if (ioctl(self->fd, CDROMMULTISESSION, &ms) == -1)
            XSRETURN_UNDEF;
        if (ms.xa_flag) 
            XSRETURN_YES;
        else
            XSRETURN_NO;
    }
#line 1787 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_ioctl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_ioctl)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, func, arg");
    {
	CDROM *	self;
	int	func = (int)SvIV(ST(1))
;
	SV *	arg = ST(2)
;
#line 827 "CDROM.xs"
        unsigned char *data;
        STRLEN dlen, need;
#line 1808 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::ioctl() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 830 "CDROM.xs"
    {
        /* this is derived from Perl's pp_sys.c:pp_ioctl */
        WARN_OFF;
        data = SvPV_force(arg, dlen);
        need = IOCPARM_LEN(func);
        if (dlen < need) {
            data = SvGROW(arg, need+1);
            SvCUR_set(arg, need);
        }
        WARN_ON;
        if (ioctl(self->fd, func, data) == -1) 
            XSRETURN_UNDEF;
        XSRETURN_YES;
    }
#line 1832 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 849 "CDROM.xs"
    {
        close(self->fd);
        Safefree(self);
    }
#line 1859 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM__Addr_noop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_noop)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 859 "CDROM.xs"
    {
        croak("This should never happen");
    }
#line 1875 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM__Addr_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_add)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "addr1, addr2, ...");
    {
	CDROM_ADDR *	addr1;
	SV *	addr2 = ST(1)
;
#line 868 "CDROM.xs"
        CDROM_ADDR *delta;
        int lba1, lba2;
#line 1894 "CDROM.c"
	CDROM_ADDR *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		addr1 = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::add() -- addr1 is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 871 "CDROM.xs"
    {
        lba1 = addr1->addr.lba;

        /* second argument could be object or an integer */
        if (!sv_isobject(addr2))
            lba2 = SvIV(addr2);
        else {
            CDROM_ADDR *a = (CDROM_ADDR*) SvIV( (SV*)SvRV(addr2) );
            lba2 = a->addr.lba;
        }

        New(0, delta, 1, CDROM_ADDR);
        delta->type = CDROM_LBA;
        delta->addr.lba = lba1 + lba2;
        RETVAL = delta;
    }
#line 1921 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "addr1, addr2, swap");
    {
	CDROM_ADDR *	addr1;
	SV *	addr2 = ST(1)
;
	IV	swap = (IV)SvIV(ST(2))
;
#line 896 "CDROM.xs"
        CDROM_ADDR *delta;
        int lba1, lba2;
#line 1944 "CDROM.c"
	CDROM_ADDR *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		addr1 = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::sub() -- addr1 is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 899 "CDROM.xs"
    {
        lba1 = addr1->addr.lba;

        /* second argument could be object or an integer */
        if (!sv_isobject(addr2))
            lba2 = SvIV(addr2);
        else {
            CDROM_ADDR *a = (CDROM_ADDR*) SvIV( (SV*)SvRV(addr2) );
            lba2 = a->addr.lba;
        }

        New(0, delta, 1, CDROM_ADDR);
        delta->type = CDROM_LBA;
        delta->addr.lba = swap ? lba2 - lba1 : lba1 - lba2;
        RETVAL = delta;
    }
#line 1971 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "CLASS, type, ...");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	int	type = (int)SvIV(ST(1))
;
#line 924 "CDROM.xs"
        CDROM_ADDR *addr;
#line 1992 "CDROM.c"
	CDROM_ADDR *	RETVAL;
#line 926 "CDROM.xs"
    {
        if (type == CDROM_LBA) { 
            if (items != 3)
                croak("Usage: Linux::CDROM::Addr->new(CDROM_LBA, $frame)");
            else {
                New(0, addr, 1, CDROM_ADDR);
                addr->addr.lba = POPi;
            }
        } 
        else if (type == CDROM_MSF) {
            if (items != 5)
                croak("Usage: Linux::CDROM::Addr->new(CDROM_MSF, $min, $sec, $frame)");
            else {
                New(0, addr, 1, CDROM_ADDR);
                addr->addr.msf.minute   = (__u8)SvIV(ST(2));
                addr->addr.msf.second   = (__u8)SvIV(ST(3));
                addr->addr.msf.frame    = (__u8)SvIV(ST(4));
            }
        }
        else 
            croak("First argument to Linux::CDROM::Addr->new() must be either CDROM_LBA or CDROM_MSF");

        addr->type = type;
        to_lba(addr);
        RETVAL = addr;
    }
#line 2021 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_frame); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_frame)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;
#line 959 "CDROM.xs"
        int lba;
        char min, sec, frame;
#line 2040 "CDROM.c"
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::frame() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 962 "CDROM.xs"
    {
        lba = self->addr.lba;
        lba_to_msf(lba, &min, &sec, &frame);
        RETVAL = frame;
    }
#line 2057 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_second); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_second)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;
#line 974 "CDROM.xs"
        int lba;
        char min, sec, frame;
#line 2075 "CDROM.c"
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::second() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 977 "CDROM.xs"
    {
        lba = self->addr.lba;
        lba_to_msf(lba, &min, &sec, &frame);
        RETVAL = sec;
    }
#line 2092 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_minute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_minute)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;
#line 989 "CDROM.xs"
        int lba;
        char min, sec, frame;
#line 2110 "CDROM.c"
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::minute() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 992 "CDROM.xs"
    {
        lba = self->addr.lba;
        lba_to_msf(lba, &min, &sec, &frame);
        RETVAL = min;
    }
#line 2127 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_as_lba); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_as_lba)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::as_lba() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1004 "CDROM.xs"
    {
        RETVAL = self->addr.lba;
    }
#line 2156 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_as_msf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_as_msf)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;
#line 1014 "CDROM.xs"
        int lba;
        char min, sec, frame;
#line 2174 "CDROM.c"

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::as_msf() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1017 "CDROM.xs"
    {
        lba = self->addr.lba;
        lba_to_msf(lba, &min, &sec, &frame);
        ST(0) = sv_2mortal(newSVuv(min));
        ST(1) = sv_2mortal(newSVuv(sec));
        ST(2) = sv_2mortal(newSVuv(frame));
        XSRETURN(3);
    }
#line 2192 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Addr_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Addr_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_ADDR *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_ADDR *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Addr::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1030 "CDROM.xs"
    {
        Safefree(self);
    }
#line 2218 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::status() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1040 "CDROM.xs"
    {
        RETVAL = self->cdsc_audiostatus;
    }
#line 2246 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_abs_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_abs_addr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;
#line 1050 "CDROM.xs"
        CDROM_ADDR *addr;
#line 2263 "CDROM.c"
	CDROM_ADDR *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::abs_addr() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1052 "CDROM.xs"
    {
        New(0, addr, 1, CDROM_ADDR);
        addr->type = CDROM_LBA;
        addr->addr = self->cdsc_absaddr;
        RETVAL = addr;
    }
#line 2280 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_rel_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_rel_addr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;
#line 1065 "CDROM.xs"
        CDROM_ADDR *addr;
#line 2298 "CDROM.c"
	CDROM_ADDR *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::rel_addr() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1067 "CDROM.xs"
    {
        New(0, addr, 1, CDROM_ADDR);
        addr->type = CDROM_LBA;
        addr->addr = self->cdsc_reladdr;
        RETVAL = addr;
    }
#line 2315 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_track); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_track)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::track() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1080 "CDROM.xs"
    {
        RETVAL = self->cdsc_trk;
    }
#line 2345 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_index); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_index)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::index() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1090 "CDROM.xs"
    {
        RETVAL = self->cdsc_ind;
    }
#line 2374 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Subchannel_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Subchannel_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_SUBCHANNEL *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_SUBCHANNEL *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::Subchannel::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1100 "CDROM.xs"
    {
        Safefree(self);
    }
#line 2401 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM__TocEntry_addr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__TocEntry_addr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_TOCENTRY *	self;
#line 1110 "CDROM.xs"
        CDROM_ADDR *addr;
#line 2417 "CDROM.c"
	CDROM_ADDR *	RETVAL;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_TOCENTRY *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::TocEntry::addr() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1112 "CDROM.xs"
    {
        New(0, addr, 1, CDROM_ADDR);
        addr->type = CDROM_LBA;
        addr->addr = self->cdte_addr;
        RETVAL = addr;
    }
#line 2434 "CDROM.c"
	ST(0) = sv_newmortal();
    sv_setref_pv( ST(0), "Linux::CDROM::Addr", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__TocEntry_adr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__TocEntry_adr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_TOCENTRY *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_TOCENTRY *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::TocEntry::adr() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1125 "CDROM.xs"
    {
        RETVAL = self->cdte_adr;
    }
#line 2464 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__TocEntry_is_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__TocEntry_is_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_TOCENTRY *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_TOCENTRY *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::TocEntry::is_data() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1135 "CDROM.xs"
    {
        RETVAL = (self->cdte_ctrl & CDROM_DATA_TRACK) > 0;
    }
#line 2493 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__TocEntry_is_audio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__TocEntry_is_audio)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_TOCENTRY *	self;
	int	RETVAL;
	dXSTARG;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_TOCENTRY *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::TocEntry::is_audio() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1145 "CDROM.xs"
    {
        RETVAL = (self->cdte_ctrl & CDROM_DATA_TRACK) == 0;
    }
#line 2522 "CDROM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__TocEntry_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__TocEntry_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	CDROM_TOCENTRY *	self;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		self = (CDROM_TOCENTRY *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Linux::CDROM::TocEntry::DESTROY() -- self is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 1155 "CDROM.xs"
    {
        Safefree(self);
    }
#line 2549 "CDROM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__CDROM__Format_raw2yellow1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Format_raw2yellow1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, data");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	data = (char *)SvPV_nolen(ST(1))
;
#line 1166 "CDROM.xs"
    {
        EXTEND(SP, 6);
        ST(0) = sv_2mortal(newSVpvn(data, 12));         /* sync */
        ST(1) = sv_2mortal(newSVpvn(data+12, 4));       /* head */
        ST(2) = sv_2mortal(newSVpvn(data+16, 2048));    /* data */
        ST(3) = sv_2mortal(newSVpvn(data+2064, 4));     /* EDC */
        ST(4) = sv_2mortal(newSVpvn(data+2068, 8));     /* zero */
        ST(5) = sv_2mortal(newSVpvn(data+2076, 276));   /* ECC */
        XSRETURN(6);
    }
#line 2577 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Format_raw2yellow2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Format_raw2yellow2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, data");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	data = (char *)SvPV_nolen(ST(1))
;
#line 1182 "CDROM.xs"
    {
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSVpvn(data, 12));         /* sync */
        ST(1) = sv_2mortal(newSVpvn(data+12, 4));       /* head */
        ST(2) = sv_2mortal(newSVpvn(data+16, 2336));    /* data */
        XSRETURN(3);
    }
#line 2602 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Format_raw2green1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Format_raw2green1)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, data");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	data = (char *)SvPV_nolen(ST(1))
;
#line 1195 "CDROM.xs"
    {
        EXTEND(SP, 6);
        ST(0) = sv_2mortal(newSVpvn(data, 12));         /* sync */
        ST(1) = sv_2mortal(newSVpvn(data+12, 4));       /* head */
        ST(2) = sv_2mortal(newSVpvn(data+16, 8));       /* sub */
        ST(3) = sv_2mortal(newSVpvn(data+24, 2048));    /* data */
        ST(4) = sv_2mortal(newSVpvn(data+2072, 4));     /* EDC */
        ST(5) = sv_2mortal(newSVpvn(data+2076, 276));   /* ECC */
        XSRETURN(6);
    }
#line 2630 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Format_raw2green2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Format_raw2green2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, data");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	char *	data = (char *)SvPV_nolen(ST(1))
;
#line 1211 "CDROM.xs"
    {
        EXTEND(SP, 5);
        ST(0) = sv_2mortal(newSVpvn(data, 12));         /* sync */
        ST(1) = sv_2mortal(newSVpvn(data+12, 4));       /* head */
        ST(2) = sv_2mortal(newSVpvn(data+16, 8));       /* sub */
        ST(3) = sv_2mortal(newSVpvn(data+24, 2324));    /* data */
        ST(4) = sv_2mortal(newSVpvn(data+2348, 4));     /* EDC */
        XSRETURN(5);
    } 
#line 2657 "CDROM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__CDROM__Format_wav_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__CDROM__Format_wav_header)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, bytes");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	unsigned int	bytes = (unsigned int)SvUV(ST(1))
;
#line 1226 "CDROM.xs"
    {
        struct {
            char	RiffTag[4]; 	// 'RIFF'
            int32_t	FileLength;
            char	FormatTag[8];	// 'WAVEfmt '
            int32_t	FormatLength;	// 16
            int16_t	DataFormat;
            int16_t	NumChannels;
            int32_t	SampleRate;
            int32_t	BytesPerSecond;
            int16_t	BlockAlignment;
            int16_t	SampleDepth;
            char	DataTag[4];	// 'data'
            int32_t	DataLength;
        } header = {
            "RIFF", 0, "WAVEfmt ",
            16, 1, 2, 44100, 176400, 4, 16,
            "data", 0
        };
        header.FileLength = 36 + bytes;
        header.DataLength = bytes;
        ST(0) = sv_newmortal();
        sv_setpvn(ST(0), (char*) &header, sizeof(header));
        XSRETURN(1);
    }
#line 2700 "CDROM.c"
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Linux__CDROM); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__CDROM)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("Linux::CDROM::constant", XS_Linux__CDROM_constant, file);
        newXS("Linux::CDROM::reset_datasize", XS_Linux__CDROM_reset_datasize, file);
        newXS("Linux::CDROM::get_datasize", XS_Linux__CDROM_get_datasize, file);
        newXS("Linux::CDROM::new", XS_Linux__CDROM_new, file);
        newXS("Linux::CDROM::fh", XS_Linux__CDROM_fh, file);
        newXS("Linux::CDROM::close", XS_Linux__CDROM_close, file);
        newXS("Linux::CDROM::reopen", XS_Linux__CDROM_reopen, file);
        newXS("Linux::CDROM::capabilities", XS_Linux__CDROM_capabilities, file);
        newXS("Linux::CDROM::drive_status", XS_Linux__CDROM_drive_status, file);
        newXS("Linux::CDROM::disc_status", XS_Linux__CDROM_disc_status, file);
        newXS("Linux::CDROM::num_frames", XS_Linux__CDROM_num_frames, file);
        newXS("Linux::CDROM::next_writable", XS_Linux__CDROM_next_writable, file);
        newXS("Linux::CDROM::get_spindown", XS_Linux__CDROM_get_spindown, file);
        newXS("Linux::CDROM::set_spindown", XS_Linux__CDROM_set_spindown, file);
        newXS("Linux::CDROM::reset", XS_Linux__CDROM_reset, file);
        newXS("Linux::CDROM::eject", XS_Linux__CDROM_eject, file);
        newXS("Linux::CDROM::auto_eject", XS_Linux__CDROM_auto_eject, file);
        newXS("Linux::CDROM::close_tray", XS_Linux__CDROM_close_tray, file);
        newXS("Linux::CDROM::lock_door", XS_Linux__CDROM_lock_door, file);
        newXS("Linux::CDROM::media_changed", XS_Linux__CDROM_media_changed, file);
        newXS("Linux::CDROM::mcn", XS_Linux__CDROM_mcn, file);
        newXS("Linux::CDROM::get_vol", XS_Linux__CDROM_get_vol, file);
        newXS("Linux::CDROM::set_vol", XS_Linux__CDROM_set_vol, file);
        newXS("Linux::CDROM::play_msf", XS_Linux__CDROM_play_msf, file);
        newXS("Linux::CDROM::play_ti", XS_Linux__CDROM_play_ti, file);
        newXS("Linux::CDROM::pause", XS_Linux__CDROM_pause, file);
        newXS("Linux::CDROM::resume", XS_Linux__CDROM_resume, file);
        newXS("Linux::CDROM::start", XS_Linux__CDROM_start, file);
        newXS("Linux::CDROM::stop", XS_Linux__CDROM_stop, file);
        newXS("Linux::CDROM::read1", XS_Linux__CDROM_read1, file);
        newXS("Linux::CDROM::read2", XS_Linux__CDROM_read2, file);
        newXS("Linux::CDROM::read_audio", XS_Linux__CDROM_read_audio, file);
#if XSubPPtmpAAAA
        newXS("Linux::CDROM::read_cooked", XS_Linux__CDROM_read_cooked, file);
#endif
        newXS("Linux::CDROM::read_raw", XS_Linux__CDROM_read_raw, file);
        newXS("Linux::CDROM::poll", XS_Linux__CDROM_poll, file);
        newXS("Linux::CDROM::toc", XS_Linux__CDROM_toc, file);
        newXS("Linux::CDROM::toc_entry", XS_Linux__CDROM_toc_entry, file);
        newXS("Linux::CDROM::is_multisession", XS_Linux__CDROM_is_multisession, file);
        newXS("Linux::CDROM::ioctl", XS_Linux__CDROM_ioctl, file);
        newXS("Linux::CDROM::DESTROY", XS_Linux__CDROM_DESTROY, file);
        newXS("Linux::CDROM::Addr::noop", XS_Linux__CDROM__Addr_noop, file);
        newXS("Linux::CDROM::Addr::add", XS_Linux__CDROM__Addr_add, file);
        newXS("Linux::CDROM::Addr::sub", XS_Linux__CDROM__Addr_sub, file);
        newXS("Linux::CDROM::Addr::new", XS_Linux__CDROM__Addr_new, file);
        newXS("Linux::CDROM::Addr::frame", XS_Linux__CDROM__Addr_frame, file);
        newXS("Linux::CDROM::Addr::second", XS_Linux__CDROM__Addr_second, file);
        newXS("Linux::CDROM::Addr::minute", XS_Linux__CDROM__Addr_minute, file);
        newXS("Linux::CDROM::Addr::as_lba", XS_Linux__CDROM__Addr_as_lba, file);
        newXS("Linux::CDROM::Addr::as_msf", XS_Linux__CDROM__Addr_as_msf, file);
        newXS("Linux::CDROM::Addr::DESTROY", XS_Linux__CDROM__Addr_DESTROY, file);
        newXS("Linux::CDROM::Subchannel::status", XS_Linux__CDROM__Subchannel_status, file);
        newXS("Linux::CDROM::Subchannel::abs_addr", XS_Linux__CDROM__Subchannel_abs_addr, file);
        newXS("Linux::CDROM::Subchannel::rel_addr", XS_Linux__CDROM__Subchannel_rel_addr, file);
        newXS("Linux::CDROM::Subchannel::track", XS_Linux__CDROM__Subchannel_track, file);
        newXS("Linux::CDROM::Subchannel::index", XS_Linux__CDROM__Subchannel_index, file);
        newXS("Linux::CDROM::Subchannel::DESTROY", XS_Linux__CDROM__Subchannel_DESTROY, file);
        newXS("Linux::CDROM::TocEntry::addr", XS_Linux__CDROM__TocEntry_addr, file);
        newXS("Linux::CDROM::TocEntry::adr", XS_Linux__CDROM__TocEntry_adr, file);
        newXS("Linux::CDROM::TocEntry::is_data", XS_Linux__CDROM__TocEntry_is_data, file);
        newXS("Linux::CDROM::TocEntry::is_audio", XS_Linux__CDROM__TocEntry_is_audio, file);
        newXS("Linux::CDROM::TocEntry::DESTROY", XS_Linux__CDROM__TocEntry_DESTROY, file);
        newXS("Linux::CDROM::Format::raw2yellow1", XS_Linux__CDROM__Format_raw2yellow1, file);
        newXS("Linux::CDROM::Format::raw2yellow2", XS_Linux__CDROM__Format_raw2yellow2, file);
        newXS("Linux::CDROM::Format::raw2green1", XS_Linux__CDROM__Format_raw2green1, file);
        newXS("Linux::CDROM::Format::raw2green2", XS_Linux__CDROM__Format_raw2green2, file);
        newXS("Linux::CDROM::Format::wav_header", XS_Linux__CDROM__Format_wav_header, file);

    /* Initialisation Section */

#line 124 "CDROM.xs"
{
    CDERR = get_sv("Linux::CDROM::error", TRUE);
    SvUPGRADE(CDERR, SVt_PVIV);
    reg_error(DEVICE_CDROM_NO_ERROR);
    SvIOK_on(CDERR);
    DATSIZE = NEWSV(0,0);
    SvUPGRADE(DATSIZE, SVt_IV);
    SvIOK_on(DATSIZE);
    SvREADONLY_on(DATSIZE);

    /* overload stuff */
    PL_amagic_generation++;
    newXS("Linux::CDROM::Addr::()", XS_Linux__CDROM__Addr_noop, file);
    newXS("Linux::CDROM::Addr::(+", XS_Linux__CDROM__Addr_add, file);
    newXS("Linux::CDROM::Addr::(-", XS_Linux__CDROM__Addr_sub, file);
}

#if XSubPPtmpAAAA
#endif
#line 2816 "CDROM.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

